//-----------------------------------------------------------------------------
// w3dChat.js - Chat- und Command-Funktionen in w3d.htm             2016-02-17

var ChatPartner = "";
var ChatAddrId = 0;
var ChatStr = "";
var bChatInpVisible;
var bChatMode;
var ChatBoard, ChatInputLine, ChatLabel, ClearButton;

//-----------------------------------------------------------------------------
// Initialisierung aller Komponenten, die an der Chat-Funktion beteiligt sind.

function createChatBoard() {

    ChatBoard = document.createElement('div');
    ChatBoard.id = "chatBoard";
    ChatBoard.style.position = 'absolute';
    ChatBoard.style.width = wWidth/2;
    ChatBoard.style.height = 1;
    ChatBoard.style.left = '0px';
    ChatBoard.style.top = '85px';
    ChatBoard.style.color = '#003';
    ChatBoard.style.backgroundColor = '#ffb';
    ChatBoard.style.opacity = '0.6';
    ChatBoard.innerHTML = "";

    ChatLabel = document.createElement('div');
    ChatLabel.id = 'chatlabel';
    ChatLabel.style.cssText = 'padding:2px 2px 2px 2px;font-size:12px;text-align:left;background-color:#004';
    ChatLabel.style.position = 'absolute';
    ChatLabel.style.color = '#fff';
    ChatLabel.style.opacity = '0.8';
    ChatLabel.style.top = '50px';
    ChatLabel.style.left = '0px';
    ChatLabel.style.width = '140px';
    ChatLabel.style.height = '19px';
    ChatLabel.innerHTML = "Nachricht an wen?";

    ChatInputLine = document.createElement('input');
    ChatInputLine.setAttribute("type", "text");
    ChatInputLine.setAttribute("id", "chatinput");
    ChatInputLine.style.position = 'absolute';
    ChatInputLine.style.color = '#ff5';
    ChatInputLine.style.backgroundColor = '#025';
    ChatInputLine.style.opacity = '0.8';
    ChatInputLine.style.top = '49px';
    ChatInputLine.style.left = '144px';
    ChatInputLine.style.width = '500px';
    ChatInputLine.style.height = '17px';

    ChatInputLine.addEventListener('keydown', function(e) {
        if (e.keyCode == 13)
            sendChatMsg();
    }, true);

    ClearButton = document.createElement('input');
    ClearButton.setAttribute("type", "button");
    ClearButton.setAttribute("value", "Clear");
    ClearButton.style.position = 'absolute';
    ClearButton.style.top = '49px';
    ClearButton.style.left = '652px';
    ClearButton.style.width = '60px';
    ClearButton.style.height = '24px';
    ClearButton.setAttribute("onClick", "clearChatBoard()");

    resizeChat();                       // an Fensterbreite anpassen

    bChatMode = false;                  // Chat vorerst passiv
    bChatInpVisible = false;
}

function resizeChat() {
    if (ChatInputLine === undefined)
        return;                         // zu frueh
    var wid = wWidth - 360;
    if (wid < 200)
        wid = 200;
    ChatInputLine.style.width = wid+'px';
    ClearButton.style.left = (wid+154)+'px';
}

//-----------------------------------------------------------------------------

function clearChatBoard() {
    var inhalt = "chatend=" + MyUserId;
    xchgChat(inhalt);
    ChatStr = "";
    ChatBoard.innerHTML = "";
    ChatInputLine.value = "";
}

//-----------------------------------------------------------------------------

function writeChatBoard(msg) {

    ChatStr = ChatStr + msg;            // neue Meldung(en) anhaengen
    var lCnt = 0;
    var str = ChatStr;
    for (lCnt = 0; ; lCnt++) {          // Anzahl Zeilen ermitteln
        var i = str.search("<br />\n");
        if (i < 0)
            break;
        str = str.substring(i+7, str.length);
    }
    while (lCnt > 12) {                 // Anzahl Zeilen begrenzen
        var i = ChatStr.search("<br />\n");
        if (i > 0)
            ChatStr = ChatStr.substring(i+7, ChatStr.length);
        lCnt--;
    }
    ChatBoard.innerHTML = ChatStr;
    if (ChatAddrId < 1) {               // letzten Chatpartner anwaehlen
        var dpkt = msg.indexOf(":");
        var pref = msg.indexOf("Ich an ");
        if (dpkt > 2) {
            var pName = msg.substr(0, dpkt);
            if (pref == 0)
                pName = pName.substr(7, pName.length);
            for (var id = 0; id < MAX_USER; id++) {
                if (userName[id] == pName) {
                    selectChatPartner(pName, id);
                    break;
                }
            }
        }
    }
}

//-----------------------------------------------------------------------------
// Return-Taste wurde bei offener Chat-Eingabe betaetigt

function sendChatMsg() {
    if (ChatInputLine.value == "")      // Leereingabe ignorieren
        return;
    if (ChatPartner == "") {
        if (!HandleCommand(ChatInputLine.value))
            ChatInputLine.value = "<===  an wen bitte?";
        else
            ChatInputLine.value = "";
        return;
    }
    var inhalt = "chataddr=" + ChatPartner + "&id=" + ChatAddrId
        + "&sender=" + MyName + "&myid=" + MyUserId + "&msg=" + ChatInputLine.value;
    xchgChat(inhalt);
    writeChatBoard("Ich an " + ChatPartner + ":  " + ChatInputLine.value + "<br />\n");
    ChatInputLine.value = "";
}

function recallChatDialog() {
    xchgChat("chatdialog=" + MyUserId);
}

//-----------------------------------------------------------------------------

function xchgChat(inhalt) {
    xmlhttp = new XMLHttpRequest();
    xmlhttp.onreadystatechange = function() {
        if ((xmlhttp.readyState == 4) && (xmlhttp.status == 200)) {
            var rxText = xmlhttp.responseText;
            var lines = rxText.split("|");
            if (lines[0] == "chat") {
                writeChatBoard(lines[1]);
            } else if (rxText != "ok") {
//                alert("xchgChat: "+rxText);
            }
        }
    };
    xmlhttp.open("GET", "../php/xchat.php?" + inhalt, true);
    xmlhttp.send();
}

//-----------------------------------------------------------------------------
// Chat-Partner wurde durch Anklicken des Avatars selektiert.

function selectChatPartner(name, id) {
    ChatInputLine.value = "";           // evt Fehlermeldung loeschen
    ChatPartner = name;
    ChatAddrId = id;
    if (!bChatInpVisible)
        setChatMode(true);
    ChatLabel.innerHTML = "Nachricht an <b>" + ChatPartner + "</b>: ";
}

//-----------------------------------------------------------------------------
// Chat-Modus ein- und ausschalten; es wird nur die Sichtbarkeit gesteuert.

function setChatMode(mode) {
    bChatMode = mode;
    if (mode) {
        container.appendChild(ChatInputLine);
        container.appendChild(ChatLabel);
        container.appendChild(ClearButton);
        container.appendChild(ChatBoard);
        bChatInpVisible = true;
    } else {
        container.removeChild(ChatInputLine);
        container.removeChild(ChatLabel);
        container.removeChild(ClearButton);
        container.removeChild(ChatBoard);
        bChatInpVisible = false;
    }
}

function setCommandMode() {
    if (!bChatInpVisible)
        setChatMode(true);
    ChatInputLine.value = "";
    ChatPartner = "";
    ChatAddrId = 0;
    ChatLabel.innerHTML = "<b>Command Input</b>: ";
}

//-----------------------------------------------------------------------------
// Kommandoeingabe in der Chat-Zeile

function HandleCommand(str) {

    if (str.slice(0, 3) == "go ") {
        var dest = str.slice(3);
        var parms = dest.split(" ");
        var p1 = parms[0];
        if (p1.indexOf("w") == 0) {
            var qid = parseInt(p1.slice(1));
            if ((qid < 1010) || (qid > 9898)) {
                dbgMessage = "*** Unzulaessige Tile-ID: " + qid;
                return true;
            }
            // etwas aus der Tile-Mitte verschoben positionieren
            posX = (Math.floor(qid/100)-50) * LEN_QUAD + 3;
            posY = 3.0;
            posZ = (qid%100-50) * LEN_QUAD + 20;
            rotY = 0;
        } else {
            if (parms.length < 3) {
                dbgMessage = "*** go-Kommando braucht Parameter x, y und z.";
                return true;
            }
            posX = parseFloat(parms[0]);
            posY = parseFloat(parms[1]);
            posZ = parseFloat(parms[2]);
        }
        var cam = new Array("FPV", posX, posY, posZ, 0, rotY, 0);
        changeCamera(cam, 0);
        return true;
    }
    return false;
}

