//---------------------------------------------------------------------------
// w3dTracks.js - Aufbau und Verwaltung Strassen/Schienensysteme  2016-01-25


var buildTrackObject = function(trkPar) {

    // ein kurzes gerades Stück Schiene anlegen

    var schwGeo = new THREE.Geometry();
    var mat = new THREE.MeshLambertMaterial({color: 0x4682B4, side: THREE.DoubleSide});
    var geo = new THREE.CubeGeometry(0.05, 0.12, 1.0);
    var obj = new THREE.Mesh(geo, mat);
    obj.position.set(-0.70, 0.12, 0.5);
    obj.updateMatrix();
    schwGeo.merge(obj.geometry, obj.matrix);

    obj = new THREE.Mesh(geo, mat);
    obj.position.set(0.70, 0.12, 0.5);
    obj.updateMatrix();
    schwGeo.merge(obj.geometry, obj.matrix);

    geo = new THREE.CubeGeometry(2.10, 0.10, 0.25);
    obj = new THREE.Mesh(geo, mat);         //@@ eher braun!
    obj.position.set(0, 0.02, 0.20);
    obj.updateMatrix();
    schwGeo.merge(obj.geometry, obj.matrix);

    var schwObj = new THREE.Mesh(schwGeo, mat);

//    alert("faces.length="+schwGeo.faces.length);
    var brCol = 0x664411;
    for (var i = 0; i < schwGeo.faces.length; i++)
        schwGeo.faces[i].vertexColors = brCol;



    var trkGeo = new THREE.Geometry();

    var xp, yp, zp, xr, yr, zr, dx, dz;
    
    for (var n = 0; n < trkPar.length; n++) {
        var trk = trkPar[n];
        if (trk === undefined)
            break;
        if (trk[0] == 0) {              // Start eines Abschnitts
            xp = trk[3];
            yp = trk[4];
            zp = trk[5];
            xr = trk[6] * Math.PI/180;
            yr = trk[7] * Math.PI/180;
            zr = trk[8] * Math.PI/180;
            dx = Math.sin(yr);
            dz = Math.cos(yr);
            continue;
        }

        if (trk[0] == 1) {              // Ende des laufenden Abschnitts
            continue;
        }

        if (trk[0] == 2) {              // gerades Streckenstueck
            var len = trk[1];
            while (len > 0) {
                obj = schwObj.clone();
                if (len < 1.0)
                    obj.scale.set(1.0, 1.0, len);
                obj.position.set(xp, yp, zp);
                obj.rotation.y = yr;
                obj.updateMatrix();
                trkGeo.merge(obj.geometry, obj.matrix);
                xp += dx;
                if (len < 1.0)
                    zp += len*dz;
                else
                    zp += dz;
                len -= 1.0;
                if (len < 0)
                    len = 0;
            }
            continue;
        }

        if (trk[0] == 3) {              // gebogenes Streckenstueck
            for (var i = 0; i < trk[1]; i++) {
                dyr = -1.5*Math.PI/180;
                obj = schwObj.clone();
                obj.position.set(xp, yp, zp);
                obj.rotation.y = yr + dyr/2;
                obj.updateMatrix();
                trkGeo.merge(obj.geometry, obj.matrix);
                yr += dyr;
                dx = Math.sin(yr);
                dz = Math.cos(yr);
                xp += dx;
                zp += dz;
            }
            continue;
        }

        if (trk[0] == 4) {              // Wegpunkt-Definition
            
            continue;
        }

        if (trk[0] == 5) {              // Abzweigung
            
            continue;
        }

        if (trk[0] == 6) {              // Anschluss an Wegpunkt
            
            continue;
        }
    }
    return new THREE.Mesh(trkGeo, mat);
};

