//--------------------------------------------------------------------------
// w3dUser.js - Verwaltung der Avatarfiguren                     2016-02-17

var numUser;
var userPos;
var userObj;
var bNewUserPos;
var userName;
var avaLabel;

//-----------------------------------------------------------------------------

function initUserData() {

    numUser = 0;
    userPos = new Array(MAX_USER);      // Array der Avatar-Koordinaten
    for (var i = 0; i < MAX_USER; i++) {// 0  1    2   3 4 5 6    7    8    9   10
        userPos[i] = new Array(12);     // ID Zeit Sts x y z xRot yRot vMov sec flg
        userPos[i][10] = 0;             // Flags auf Null setzen
    }
    userObj = new Array(MAX_USER);
    bNewUserPos = false;

    userName = new Array(MAX_USER);
    for (var i = 0; i < MAX_USER; i++)  // mit Defaultnamen vorbelegen
        userName[i] = "User" + i;

    var avaLabel = new Array(MAX_USER); // Namensschild je User-Avatar
    for (var i = 0; i < MAX_USER; i++) {
        avaLabel[i] = document.createElement('div');
        avaLabel[i].id = "Ava"+i;
        avaLabel[i].style.position = 'absolute';
        avaLabel[i].style.width = 10;
        avaLabel[i].style.height = 1;
        avaLabel[i].style.top = '70px';
        avaLabel[i].style.left = '0px';
        avaLabel[i].style.backgroundColor = '#ffb';
        avaLabel[i].style.opacity = '0.6';
        avaLabel[i].innerHTML = "";
        document.body.appendChild(avaLabel[i]);
    }
}

//-----------------------------------------------------------------------------
// Liste der User-Positionen wurde vom Server empfangen.

function recvUserPos(lines) {

    var numOnline = 0;
    var i;
    for (i = 0; i < MAX_USER; i++) {
        var line = lines[i+1];
        if (line.length < 16)
            break;
        // Daten eines Users
        var parms = line.split(";");
        userPos[i][0] = parseInt(parms[0]);     // User-ID
        userPos[i][1] = parseInt(parms[1]);     // Zeit
        userPos[i][2] = parseInt(parms[2]);     // state
        userPos[i][3] = parseFloat(parms[3]);   // xPos
        userPos[i][4] = parseFloat(parms[4]);   // yPos
        userPos[i][5] = parseFloat(parms[5]);   // zPos
        userPos[i][6] = parseFloat(parms[6]);   // xRot
        userPos[i][7] = parseFloat(parms[7]);   // yRot
        userPos[i][8] = parseFloat(parms[8]);   // vMove in m/s
        userPos[i][9] = 0;
        if (parms.length > 9)
            userPos[i][9] = parseInt(parms[9]); // secDif
        if (userPos[i][2] == 1) {
            numOnline++;                        // aktive zaehlen
            userPos[i][10] = 1;     //@@ neu ankommende melden!
        }
    }
    numUser = i;
    bNewUserPos = true;
}

//-----------------------------------------------------------------------------
// Liste der User-Namen wurde vom Server empfangen.

function recvUserNames(lines) {

    for (var i = 1; i < MAX_USER; i++) {
        var line = lines[i];
        if (line.length < 5)
            break;
        var parms = line.split(";");
        var id = parseInt(parms[0]);
        if (id >= MAX_USER)
            continue;
        userName[id] = parms[1];
        if (userName[id] == MyName)
            MyUserId = id;
    }
}

//-----------------------------------------------------------------------------
// Avatare der User bauen; Anzahl noch unbekannt hier.

function buildUserAvatars() {
    var i0 = -20;
    for (var i = 0; i < MAX_USER; i++) {
        userObj[i] = new AvatarObj();   // in w3dTools.js
        userObj[i].position.set(i0+i*3, -1000, 0);
        scene.add(userObj[i]);
        if ((i % 5) == 4)               // 5er-Gruppen
            i0 += 1;
    }
}

//-----------------------------------------------------------------------------
// Avatare der User positionieren und ggf. bewegen

function cycleUserAvatars() {

    var str = "";
    for (var i = 0; i < numUser; i++) {
        var id = userPos[i][0];
        var stdDif = userPos[i][9] / 3600;
        if (stdDif > 5*24)              // User zu lange offline
            continue;

        var dist = getUserDistance(i);
        var uName = userName[id];
        if (dist > LEN_QUAD*2.5)        // User zu weit weg
            continue;

        var dx = posX - userPos[i][3];
        var dz = posZ - userPos[i][5];
        var peil = getPeilung(dx, dz, rotY);
                                        // Blickrichtung des Users
        var rot = -(userPos[i][7] + 180) * Math.PI / 180;
        var rotx = -userPos[i][6] * Math.PI / 180;
        var state = userPos[i][2];
        if (id == MyUserId) {
            if ((viewMode != 0) || (curCamera != 0))
                userObj[i].position.y = posY;
            else
                userObj[i].position.y = -50;
            userObj[i].position.x = posX;
            userObj[i].position.z = posZ;
            userObj[i].rotation.y = rot + Math.PI/2;
            userObj[i].rotation.z = rotx;
            userObj[i].material.color.setHex("0xFF3300");
            userObj[i].material.opacity = 1.0;
        } else if (bNewUserPos || (state == 0)) {
            userObj[i].position.x = userPos[i][3];
            userObj[i].position.y = userPos[i][4];
            userObj[i].position.z = userPos[i][5];
            userObj[i].rotation.y = rot + Math.PI/2;
            userObj[i].rotation.z = rotx;
            if (state == 1)             // aktiv ?
                userObj[i].material.color.setHex("0xDDAA00");
            else
                userObj[i].material.color.setHex("0x3F2F2F");
            var opa = 0.9999 * (5*24 - stdDif) / (5*24);
            userObj[i].material.opacity = opa;
        } else {                        // Bewegung interpolieren
            // s = v * t, Wegstrecke in den verstrichenen Millisekunden
            var dWeg = userPos[i][8] * mspf * 0.001;
            var dx = Math.sin(rot);
            var dz = Math.cos(rot);
            userObj[i].position.x -= dx*dWeg;
            userObj[i].position.z -= dz*dWeg;
        }

        if (id != MyUserId) {
            var flg="";
            if (state == 1)
                flg = "[Online] ";
            str = str + uName + "(" + id + ") " + flg
                + "in " + dist.toFixed(0) + "m "
                + peil.toFixed(0) + "deg;   ";
        }

        // Namenlabel positionieren
        if ((id != MyUserId) && (mUseSensors == 0) && (curCamera == 0)) {
            var pos = new THREE.Vector3(userObj[i].position.x,
                userObj[i].position.y + yAugen + 0.8, userObj[i].position.z);
            var pkt = toXYCoords(pos);
            var label = document.getElementById("Ava"+i);
            if ((pkt.x < 25) || (pkt.x > wWidth-25)
             || (pkt.y < 12) || (pkt.y > wHeight-12)
             || (Math.abs(peil) > 60)) {
                label.style.left = '10px';
                label.style.top = '10px';
                label.innerHTML = "";   // ausserhalb des Bildes
            } else {                    // Label ueber dem Kopf
                if (state == 1)
                    label.style.backgroundColor = "#ffb";
                else
                    label.style.backgroundColor = "#999";
                label.style.left = (pkt.x-25) + 'px';
                label.style.top = (pkt.y-13) + 'px';
                label.innerHTML = uName;
            }
        }
    }
    bNewUserPos = false;
    dbgLine.update(str);
}

function getUserDistance(id) {
    if (id >= numUser)
        return -1;
    var x = posX + dxMove*(vMove-0.6);
    var z = posZ + dzMove*(vMove-0.6);
    var dx = x - userPos[id][3];
    var dz = z - userPos[id][5];
    return Math.sqrt(dx*dx + dz*dz);
}

function testUserPos (xp, zp) {
    for (var i = 0; i < numUser; i++) {
        if (userPos[i][0] != MyUserId) {
            var hu = userPos[i][4];
            if ((getUserDistance(i) < 0.2) && (posY > hu-0.2) && (posY < hu+2.0))
                return false;
        }
    }
/*
        while (1) {
            for (var i = 0; i < numUser; i++) {
                if (userPos[i][0] != MyUserId) {
                    var hu = userPos[i][4];
                    if ((getUserDistance(i) < 0.2) && (posY > hu-0.2) && (posY < hu+2.0)) {
                        // zu dicht an anderem User: falls in Bewegung, zurueckweichen
                        if (Math.abs(vMove) > 0.1)
                            return false;
                        // selber stehend: zur Seite gehen
                        var xu = userPos[i][3];
                        var zu = userPos[i][5];
                        var dx = xu - posX;
                        var dz = zu - posZ;
                        if (dx <= 0.2)
                            
                            
                        return false;
                    }
                }
            }
        }
*/
    return true;
}

//-----------------------------------------------------------------------------
// Avatar eines Users anklicken zum Chatten

function doClickUser(selX, selY) {

    for (var i = 0; i < numUser; i++) {
        var label = document.getElementById("Ava"+i);
        var name = label.innerHTML;
        if (name == "")
            continue;
        var x = parseInt(label.style.left);
        var y = parseInt(label.style.top);
        if ((selX > x) && (selX < x+40) && (selY > y-10) && (selY < y+60)) {
            selectChatPartner(name, userPos[i][0]);
            break;
        }
    }
}
