<?php
/*=============================================================================
 * login.php - Anmeldung zum 3D-Wiki
 *
 * Eingabeformular auswerten, User-Stammdaten fuehren,
 * Start in 3D-Welt parametrieren
 *
 * 2016-01-03 Neue Rahmenwelt w3d.htm unterstuetzen
 * 2015-12-10 Jetzt ein Statusfile je User
 * 2015-11-27 Automatische Weiterleitung zur Frame-Seite
 * 2015-11-23 Startparameter in der URL der Startwelt uebergeben
 * 2015-11-18 Beginn
 *============================================================================*/

$_Stand = 'V16.02.16';



echo '<!DOCTYPE html>
<html><head><meta charset="utf-8"></head>
';



//-----------------------------------------------------------------------------

if (!isset($_GET['username']))
  exit('*** Ungueltiger Aufruf ohne Anmeldung');

$MyName = $_GET['username'];
if ($MyName == '')
  exit('*** Ganz ohne Anmeldung geht es leider nicht ...');
if (strlen($MyName) < 3)
  exit('*** Ein Username muss mindestens drei Zeichen lang sein.');
if (strlen($MyName) > 20)
  exit('*** Bitte nicht &uuml;bertreiben: maximal 20 Zeichen f&uuml;r einen Usernamen.');



$StartWelt = '../world/w3d.htm';
if (isset($_GET['frame']))
  $StartWelt = $_GET['frame'];

date_default_timezone_set('Europe/Berlin');


// User-Stammdaten-Datei muss existieren; mindestens ein Dummy-User
// # User-Stammdaten
// 2015-11-17 20:00:00;0;Mustermann;

$UsFName = '../user/user.txt';
if (!file_exists($UsFName))
  exit('*** Tja, '.$UsFName.' ist nicht zu finden.<br />'
  	.'Sieht so aus, als ob die Installation unvollst&auml;ndig ist!');

// User-Stammdaten zum Lesen und Schreiben oeffnen
$fUs = fopen($UsFName, 'r+') or exit('*** Kann '.$UsFName.' nicht &ouml;ffnen');

$MyUserId = 0;
$count = 0;
$bNew = true;
while (!feof($fUs)) {
  $line = rtrim(fgets($fUs));
  if ((strlen($line) > 1) && (substr($line, 0, 1) == "#"))
    continue;
  if (strlen($line) < 22)
    break;
  $items = explode(";", $line);
  if ($items[2] == $MyName) {
    echo '<p><big><strong>Hallo '.$MyName.', willkommen zur&uuml;ck!</strong></big></p>';
    $MyUserId = $items[1];
    $bNew = false;
    break;
  }
  $count++;
}

$jetzt = date("Y-m-d").' '.date("H:i:s");
$dNow = sscanf ($jetzt, "%d-%d-%d %d:%d:%d");
$secNow = ((($dNow[1]*30 + $dNow[2])*24 + $dNow[3])*60 + $dNow[4])*60 + $dNow[5];


// Logfile oeffnen; jeden Monat neues Logfile beginnen
$LogName = sprintf("../log/log_%02d%02d.txt", date("y") % 100, date("n"));
$fLog = fopen($LogName, 'a');


// einen neuen User hinten anhaengen; User-ID ist die laufende Nummer
if ($bNew) {
  $MyUserId = $count;
  fprintf ($fUs, "%s;%d;%s;\r\n", $jetzt, $MyUserId, $MyName);
  echo '<p><big><strong>Hallo '.$MyName.', willkommen zu deinem ersten Besuch!</strong><br />'
  	.'Deine User-ID ist '.$MyUserId.'</big></p>';
  fprintf($fLog, "NewUser: %s; %s; ID %d, %s\r\n",
      $jetzt, getenv("REMOTE_ADDR"), $MyUserId, $MyName);
}
fclose($fUs);



// Default-Startposition bezogen auf Ursprung der Szene; Absolut-Koordinaten
$xPos = 1.0;					// etwas nach rechts verschoben
$yPos = 1.5;					// Augenhoehe ueber Boden
$zPos = 14.0;					// nach hinten verschoben
$xRot = 0;						// Nase waagrecht
$yRot = 350;					// leicht nach links schauend
$vMov = 2.0;					// leichte Vorwaertsbewegung bei Neustart

$tDelay = 2;					// Sekunden Wartezeit zur Weiterleitung
$state = 1;

//-----------------------------------------------------------------------------
// Je User ein Statusfile mit fester L�nge:
// 0     1       2        3     4        5     6     7
// Zeit; Status; xPosAbs; yPos; zPosAbs; xRot; yRot; Speed;

$bNew = false;
$StFName = sprintf("../user/st%03u.txt", $MyUserId);
if (file_exists($StFName)) {		// Statusfile bereits vorhanden?
  $fSt = fopen($StFName, 'r');
  $line = fgets($fSt);
  if (strlen($line < 60)) {
    $bNew = true;					// wohl ungueltig: neu anlegen
    echo '<p>'.$MyName.', deine Zustandsdaten sind ung&uuml;eltig...</p>';
  } else {
    $items = explode(";", $line);
    $zeit = $items[0];
    $state = intval($items[1]);
    $xPos = floatval($items[2]);
    $yPos = floatval($items[3]);
    $zPos = floatval($items[4]);
    $xRot = floatval($items[5]);
    $yRot = floatval($items[6]);
    $vMov = floatval($items[7]);
    $dat1 = sscanf ($zeit, "%d-%d-%d %d:%d:%d");
    $min1 = (($dat1[1]*30 + $dat1[2])*24 + $dat1[3])*60 + $dat1[4];
    if (($state == 0) || ($min1 < $secNow-180)) {
      echo '<p>'.$MyName.', du warst zuletzt online: '.$zeit.'</p>';
      $zeit = $jetzt;
      $state = 1;
    } else {
      echo '<p>'.$MyName.', du bist ja schon aktiv drin!</p>';
      $tDelay = 1;
    }
  }
  fclose ($fSt);
} else {							// noch kein Statusfile:
  echo '<p>'.$MyName.', dein Zustandsdatensatz wird neu angelegt.</p>';
  $tDelay = 10;
  $bNew = true;
}

if ($bNew)
  $fSt = fopen($StFName, 'w');		// File neu anlegen
else
  $fSt = fopen($StFName, 'r+');		// zum Überschreiben oeffnen

$data = sprintf("%s;%d;%.3f;%.3f;%.3f;%.1f;%.1f;%.3f;",
        $jetzt, $state, $xPos, $yPos, $zPos, $xRot, $yRot, $vMov);
$data = str_pad($data, 72, ".");	// auf feste Laenge auffuellen
fclose ($fSt);
  
fprintf($fLog, "Login:  %s; ID %d, %s; %s; %s\r\n",
	$jetzt, $MyUserId, $MyName, getenv("REMOTE_ADDR"), getenv("HTTP_USER_AGENT"));






fclose($fLog);



//-----------------------------------------------------------------------------
// Parameter beim Aufruf der Seite als URL-Ergaenzung mitgeben

$ori = 0;
if (isset($_GET['orient']))
  $ori = $_GET['orient'];
$vmod = 0;
if (isset($_GET['viewmode']))
  $vmod = $_GET['viewmode'];
$wsiz = 0;
if (isset($_GET['winsize']))
  $wsiz = $_GET['winsize'];
$fog = 150;
if (isset($_GET['fogrange']))
  $fog = $_GET['fogrange'];

$urlPar = '?nam='.$MyName.
       '&xp='.$xPos.'&yp='.$yPos.'&zp='.$zPos.
       '&xr='.$xRot.'&yr='.$yRot.'&spd='.$vMov.
       '&st='.$vmod.'&win='.$wsiz.
       '&fog='.$fog.'&ori='.$ori;

echo '<p><big>Du wirst gleich in die 3D-Welt weitergeleitet.</big></p>';
echo '<p>Falls nicht, kannst du hier eintreten: <a href="'.$StartWelt.$urlPar.'"><big>ENTER</big></a></p>';
echo '<hr />';
echo '<p><br />Zur&uuml;ck zur <a href="index.htm">Anmeldung</a></p>';
echo '<p><small><i>Stand '.$_Stand.'</i></small></p>';
echo '<hr />';


// Diese Zeile auskommentieren, um die automatische Weiterleitung zu verhindern:

echo '<meta http-equiv="refresh" content="'.$tDelay.'; URL='.$StartWelt.$urlPar.'">';



//-----------------------------------------------------------------------------
// Testausgaben optional
/*
echo '<p><big>Debug-Ausgaben:</big></p>';
echo '<pre>';
print_r ($_REQUEST);
echo 'urlPar='.$urlPar."\r\n";
print_r ($_SERVER);
echo '</pre>';
*/

?>
