<?php    // 2016-02-16

$MAX_USER = 100;

date_default_timezone_set('Europe/Berlin');

//---------------------------------------------------------------------------
// zyklische Positionsmeldung und -abfrage

if (isset($_GET['pos'])) {
  $posi = $_GET['pos'];

  $items = explode(";", $posi);
  $myId = intval($items[0]);
  $xPos = floatval($items[1]);
  $yPos = floatval($items[2]);
  $zPos = floatval($items[3]);
  $xRot = floatval($items[4]);
  $yRot = floatval($items[5]);
  $vMov = floatval($items[6]);
  $state = 1;

  $jetzt = date("Y-m-d").' '.date("H:i:s");
  $dNow = sscanf ($jetzt, "%d-%d-%d %d:%d:%d");
  $yrNow = $dNow % 100;
  $secNow = (((($yrNow*12 + $dNow[1])*30 + $dNow[2])*24 + $dNow[3])*60 + $dNow[4])*60 + $dNow[5];

  // Das eigene Statusfile zum Ueberschreiben oeffnen und aktualisieren

  $StFName = sprintf("../user/st%03u.txt", $myId);
  $fSt = fopen($StFName, 'r+');
  $line = sprintf("%s;%d;%.3f;%.3f;%.3f;%.1f;%.1f;%.3f;%d;",
        $jetzt, $state, $xPos, $yPos, $zPos, $xRot, $yRot, $vMov, $secNow);
  $line = str_pad($line, 80, ".");	// auf feste Laenge auffuellen
  fwrite($fSt, $line);
  fclose($fSt);

  $first = false;
  if (isset($_GET['first']))
    $first = true;

  // Empfang von Chat-Messages anderer User pruefen

  if (!$first) {
    $MsgFName = sprintf("../user/msg%03u.txt", $myId);
    if (file_exists($MsgFName)) {
      $line = "";
      $fd = fopen($MsgFName, 'r');
      while (!feof($fd)) {
        $line = $line.fgets($fd);
      }
      fclose($fd);
      unlink($MsgFName);
      echo 'chat|'.$line;
      return;
    }
  }
  
  // Alle anderen Statusfiles lesen, Ergebnistext zusammenbauen und senden

  $result = "pos|";
  $fLog = 0;

  for ($id = 1; $id < $MAX_USER; $id++) {
    $fName = sprintf ("../user/st%03u.txt", $id);
    if (!file_exists($fName))
      continue;
    $fSt = fopen($fName, 'r');
    $line = fgets($fSt);
    fclose ($fSt);
    if (strlen($line) < 60)
      continue;

    $items = explode(";", $line);
    $secUsr = 3*24*3600; 
    if (isset($items[8])) {
      $sec1 = intval($items[8]);
      if ($sec1 > $secNow/2)
        $secUsr = $secNow - $sec1;
    }
    // die ID des Users voranstellen, relative Zeit hinten
    $result = $result.$id.";".$items[0].";".$items[1].";".$items[2].";".$items[3].";"
              .$items[4].";".$items[5].";".$items[6].";".$items[7].";".$secUsr."|";
    if ((($dNow[5] != 0) && !$first))
      continue;

    // einmal pro Minute andere User auf Inaktivitaet pruefen
    $items = explode(";", $line);
    if ($items[1] == "0")			// User ist schon passiv
      continue;
    $dUsr = sscanf ($items[0], "%d-%d-%d %d:%d:%d");
    $yrUsr = $dUsr % 100;
    $sec1 = (((($yrUsr*12 + $dUsr[1])*30 + $dUsr[2])*24 + $dUsr[3])*60 + $dUsr[4])*60 + $dUsr[5];
    if ($sec1 > $secNow - 180)		// ca. 3 Minuten
      continue;						// User lebt noch

    if ($id != $myId) {
      // diesen User abmelden: Zustand auf passiv setzen
      $fSt = fopen($fName, 'r+');		// zum Ueberschreiben oeffnen
      fseek($fSt, 20, SEEK_SET);		// hinter die Uhrzeit positionieren
      fwrite($fSt, "0", 1);
      fclose ($fSt);
  
      // im Protokoll vermerken
      if ($fLog == 0) {
        $LogName = sprintf("../log/log_%02d%02d.txt", date("y") % 100, date("n"));
        $fLog = fopen($LogName, 'a');
        fprintf($fLog, "Logoff: %s; ID %d; by ID %d\r\n", $items[0], $id, $myId);
      }
    }
  }

  if ($fLog != 0)
    fclose($fLog);
  echo $result;
  return;
}



//---------------------------------------------------------------------------
// die Namen aller User erfragen, (spaeter: ...fuer die es ein Statusfile gibt)

if (isset($_GET['getnames'])) {
    $result = "names|";
    $UsFName = '../user/user.txt';
    $fUs = fopen($UsFName, 'r') or exit('*** Kann '.$UsFName.' nicht oeffnen');
    while (!feof($fUs)) {
        $line = rtrim(fgets($fUs));
        if ((strlen($line) > 1) && (substr($line, 0, 1) == "#"))
            continue;
        if (strlen($line) < 22)
            break;
        $items = explode(";", $line);
        $result = $result.$items[1].";".$items[2]."|";
    }
/*
  // Hinweis an die anderen aktiven User, dass ich reinkomme
  // --> die eigene ID ist hier noch gar nicht bekannt!
  if (isset($_GET['id'])) {
    $myId = $_GET['id'];
    for ($id = 1; $id < $MAX_USER; $id++) {
      if ($id == $myId)
         continue;
      $fName = sprintf ("../user/st%03u.txt", $id);
      if (!file_exists($fName))
        continue;
      $fSt = fopen($fName, 'r');
      fseek($fSt, 20, SEEK_SET);        // hinter die Uhrzeit positionieren
      $stat = fread($fSt, 1);
      fclose ($fSt);
      if ($stat == "1") {
        
      }
    }
  }
*/
    echo $result;
    return;
}



//---------------------------------------------------------------------------

if (isset($_GET['quit'])) {
    $myId = $_GET['quit'];
    $StFName = sprintf("../user/st%03u.txt", $myId);
    if (file_exists($StFName)) {
        $fSt = fopen($StFName, 'r+');
        fseek($fSt, 20, SEEK_SET);      // hinter die Uhrzeit positionieren
        fwrite($fSt, "0", 1);           // Status offline setzen
        fclose($fSt);
    }
    return;
}



//---------------------------------------------------------------------------

if (isset($_GET['log'])) {
  $line = $_GET['log'];
  $LogFName = "../log/_log.txt";
  $fLog = fopen($LogFName, 'a');
  fwrite($fLog, $line."\n");
  fclose($fLog);
  return;
}

?>
