<?php
// xreadvsc.php - zum Upload von VSC-Files    2016-02-18

if (!isset($_GET['uid']) || !isset($_GET['qname'])) {
    echo '*** Ungueltiger Aufruf von xreadvsc.php!';
    return;
}
$qname = $_GET['qname'];
$userId = intval($_GET['uid']);

if ($userId < 1) {
    echo '*** Ungueltige User-ID!';
    return;
}

date_default_timezone_set('Europe/Berlin');

$tsName = sprintf("../user/ts%03u.txt", $userId);
$wrlDir = "../world/";
$result = "";
$fname = "";
$mode = "new";

//-----------------------------------------------------------------------------
// Inhalt eines VSC-Scripts in Textstring lesen, den Inhalt von Include-Files
// dabei einfuegen, anschliessend die Fortsetz-Zeilennummer hinterlegen.

function readVscFile($fname) {

    global $wrlDir;
    $fd = fopen($wrlDir.$fname, 'r');
    $vscText = "";
    $lCnt = 0;
    while (!feof($fd)) {
        $line = rtrim(fgets($fd));
        $lCnt++;
        $pos = strpos($line, "include");
        if (($pos !== false) && ($pos === 0)) {
            $incName = trim(substr($line, 8));
            if (!file_exists($wrlDir.$incName)) {
                $vscText = $vscText.$line." //@@*** ".$wrlDir.$incName." not found\n";
                continue;
            }
            $vscText = $vscText.$line."\n"; 
            $finc = fopen($wrlDir.$incName, 'r');
            $iCount = 0;
            while (!feof($finc)) {
                $iLine = rtrim(fgets($finc));
                $vscText = $vscText.$iLine."\n";
                $iCount++; 
            }
            fclose($finc);
            $lCnt++;
            $vscText = $vscText."//@@ENDINC ".$lCnt."\n";
            continue;
        }
        $vscText = $vscText.$line."\n"; 
    }
    fclose($fd);
    return $vscText;
}

//-----------------------------------------------------------------------------
// Anforderung ein bestimmtes VSC-Script zu laden

if (isset($_GET['vsc'])) {
    $fname = $_GET['vsc'];
    if (!file_exists($wrlDir.$fname)) {
        echo '*** '.$fname.' wurde nicht gefunden.';
        return;
    }

} else if (isset($_GET['poll'])) {
    if (!file_exists($tsName))
        return;

    $fts = fopen($tsName, 'r');         // auf Aenderung testen
    $tsText = fread($fts, filesize($tsName));
    fclose($fts);

    $pos = 0;
    while(1) {
        $nPos = strpos($tsText, $qname.';', $pos);
        if ($nPos === false)            // fuer diese Kachel nichts mehr
            break;
        $nPos += 6;
        $ePos = strpos($tsText, ';', $nPos);
        $fnam = substr($tsText, $nPos, $ePos-$nPos);
        $pos = $ePos;                   // dahinter weiter suchen
        if (!file_exists($wrlDir.$fnam))
            continue;
        $oStamp = intval(substr($tsText, $ePos+1));
        $nStamp = filemtime($wrlDir.$fnam);
        if ($nStamp != $oStamp) {       // Zeit unterschiedlich
            $fname = $fnam;
            $mode = "upd";
            break;
        }
    }
}

if ($fname != "") {
    // Inhalt der angeforderten VSC-Datei liefern
    $filetext = readVscFile($fname);
    $result = $qname.'|'.$fname.'|'.$filetext;

    // in die Tilestatusliste eintragen zur Erfassung von Aenderungen

    $tstamp = filemtime($wrlDir.$fname); // Timestamp last modified
    $vsKey = $qname.';'.$fname.';';
    $tsLine = $vsKey.$tstamp.";\n";
    $nText = $tsLine;

    if (file_exists($tsName)) {
        $fts = fopen($tsName, 'r');     // bisherigen Stand einlesen
        $siz = filesize($tsName);
        if ($siz == 0) {
            $tsText = "";
            fclose($fts);
        } else {
            $tsText = fread($fts, $siz);
            fclose($fts);
            $pos = strpos($tsText, $vsKey);
            if ($pos === false)         // nicht vorhanden: Zeile anhaengen
                $nText = $tsText.$tsLine;
            else {                      // vorhanden: Zeile austauschen
                $ePos = $pos + strlen($tsLine);
                $txt1 = substr($tsText, 0, $pos);
                $txt2 = substr($tsText, $ePos);
                $nText = $txt1.$tsLine.$txt2;
            }
        }
    }
    $fts = fopen($tsName, 'w');         // neuen Stand schreiben
    fwrite($fts, $nText);
    fclose($fts);


    // Protokoll zur Problemsuche
    $fp = fopen("../log/_vscrequest.log", 'a');
    $jetzt = date("Y-m-d").' '.date("H:i:s");
    fwrite($fp, $jetzt." ".$mode." ".$qname.":".$fname."\n");
    fclose($fp);
/*
    $fp = fopen("../log/_vsctext.vsc", 'a');
    fwrite($fp, "\n\n##################################################################################\n# ");
    fwrite($fp, $jetzt." ".$mode." ".$qname.":".$fname."\n");
    fwrite($fp, $result);
    fclose($fp);
 */
}

echo $result;
?>
