//-----------------------------------------------------------------------------

var SceneVersion = "w4.js V16.02.04";
var SceneName = "Spielwiese";

var SceneObj  = undefined;
var SceneId;

var vscName = "w1Demo2.vsc";
var vscData;


var objBild;

var sArray;                 // 2-dimensionales Array der Kacheln
var xDim = 40;              // Anzahl Kacheln in x-Richtung
var zDim = 40;              // Anzahl Kacheln in z-Richtung
var aWid = 1;               // Ausdehnung einer Kachel
var Cubes;                  // Liste der Wuerfel
var nCubes = 40;            // Anzahl der Wuerfel
var wCube = aWid*0.92;      // Kantenlaenge eines Wuerfels

var mvId = 0;               // ID eines zu verschiebenden Wuerfels oder 0
var mvFromX = 0;
var mvToX = 0;
var mvFromZ = 0;
var mvToZ = 0;
var mvDist = 0;


//-----------------------------------------------------------------------------

function buildScene(sid) {

    SceneId = sid;
    SceneObj = new THREE.Mesh();

    SceneObj.add(buildGround('../tex/grasslight.jpg'));

    var cross = setAchsenkreuz(2);      // zur Orientierung
//    cross.position.set(-34, 0.15, 24);
    SceneObj.add(cross);

    var map = THREE.ImageUtils.loadTexture('../pics/Eiaa01.jpg');
    map.wrapS = map.wrapT = THREE.RepeatWrapping;
    map.anisotropy = 16;
    var mat2 = new THREE.MeshLambertMaterial({map: map, side: THREE.DoubleSide});

    var geo = new THREE.CubeGeometry(15, 10, 0.2);
    objBild = new THREE.Mesh(geo, mat2);
    objBild.position.set(-50, 5, -35);
    SceneObj.add(objBild);



    // einige Wuerfel bauen und zur Szene hinzufuegen

    Cubes = new Array(nCubes);

    var cubeMap = THREE.ImageUtils.loadTexture('../tex/crate.gif');
    cubeMap.wrapS = cubeMap.wrapT = THREE.RepeatWrapping;
    cubeMap.anisotropy = 16;

    var cubeGeo = new THREE.CubeGeometry(wCube, wCube, wCube);
    var cubeMat = new THREE.MeshLambertMaterial({map:cubeMap, side:THREE.DoubleSide});
    var n = 0;
    for (n = 0; n < nCubes; n++) {
        Cubes[n] = new THREE.Mesh(cubeGeo, cubeMat);
        SceneObj.add(Cubes[n]);
    }


    // das "Spielfeld" als 2-dim. Array anlegen

    sArray = new Array(zDim);
    for (var z = 0; z < zDim; z++) {
        sArray[z] = new Array(xDim);
        for (var x = 0; x < xDim; x++)
            sArray[z][x] = 0;
    }

// das Array gemaess der Datenbasis auf dem Server belegen
//<?php include 'w4array.php'; ?>

    n = 0;
    for (var z = 0; z < zDim; z++) {
        for (var x = 0; x < xDim; x++) {
            if (sArray[z][x] != 0) {
                sArray[z][x] = n+1;     // ID des Wuerfels hinterlegen
                Cubes[n].position.set(aWid*(x-xDim/2), wCube/2, aWid*(z-zDim/2));
                n++;
                if (n >= nCubes)
                    break;
            }
        }
    }

    // Sichthoehe knapp ueber den Wuerfeln, leicht nach unten geneigt
    yAugen = wCube + 0.15;
//    yNeigung = -0.12;

    msLast = Date.now();

    vscRequest(vscName, sid);           // Szene aus Skript nachladen

    return SceneObj;
}

//-----------------------------------------------------------------------------

function recvSceneData(rxText) {
    if (vscData !== undefined)
        return;
    vscData = buildVscScene(vscName, rxText);
    vscData[1].name = vscName;
    registerVscData(SceneId, vscData);
}

//-----------------------------------------------------------------------------

function terminateScene() {
    if (SceneObj !== undefined)
        delete SceneObj;
}

//-----------------------------------------------------------------------------

function cycleScene(msPerFrame) {

    objBild.rotation.y -= msPerFrame * 0.001;

    if (mvId != 0) {                    // Wuerfel verschieben?
        var n = mvId-1;
        mvDist += (aWid - mvDist) * msPerFrame * 0.001;
        if (mvDist > 0.99 * aWid) {        // Zielposition erreicht?
            inhalt = "w4xchg.php?x0=" + mvFromX + "&x1=" + mvToX
                    + "&z0=" + mvFromZ + "&z1=" + mvToZ;
            xchgPosInfo(inhalt, 1);        // an den Server melden
            mvDist = aWid;
            sArray[mvFromZ][mvFromX] = 0;
            sArray[mvToZ][mvToX] = mvId;
            mvId = 0;
        }
        var dx = (mvToX - mvFromX) * mvDist;
        var dz = (mvToZ - mvFromZ) * mvDist;
        var x = aWid*(mvFromX-xDim/2) + dx;
        var z = aWid*(mvFromZ-zDim/2) + dz;
        Cubes[n].position.set(x, wCube/2, z);
    }

    //@@ Test mit Objektbewegungen

    var selObj = scene.getObjectByName("Hand_0");
    if (selObj !== undefined)
        selObj.rotation.x -= 0.015;
    selObj = scene.getObjectByName("Unterarm_0");
    if (selObj !== undefined)
        selObj.rotation.z -= 0.01;
    selObj = scene.getObjectByName("Oberarm_0");
    if (selObj !== undefined) {
        selObj.rotation.y -= 0.007;
        selObj.rotation.x -= 0.002;
    }
}

//-----------------------------------------------------------------------------

function testScenePosition(xp, yp, zp) {

    if ((xp > -55) && (xp < -45) && (yp > -20) && (yp < -30))
        return false;

    if ((yp < 0) || (yp > 1.5+wCube))    // ober- oder unterhalb ?
        return true;                    // frei

    var x = Math.floor(xp/aWid) + xDim/2;
    var z = Math.floor(zp/aWid) + zDim/2;
    if ((x < 0) || (x >= xDim) || (z < 0) || (z >= zDim))
        return true;                    // ausserhalb des Arrays

    if (sArray[z][x] == 0)
        return true;                    // freie Position

    // belegte Position: pruefen ob der Wuerfel verschiebbar ist
    if (mvId != 0)                        // wird bereits verschoben?
        return false;                    // Position noch blockiert
    if ((rotY >= 45) && (rotY < 135)) {    // nach rechts bewegt?
        if ((x < xDim-1) && (sArray[z][x+1] == 0)) {
            mvId = sArray[z][x];
            mvFromX = x;
            mvToX = x+1;
            mvFromZ = z;
            mvToZ = z;
            mvDist = 0;
        }
    } else if ((rotY >= 135) && (rotY < 225)) {    // nach unten bewegt?
        if ((z < zDim-1) && (sArray[z+1][x] == 0)) {
            mvId = sArray[z][x];
            mvFromX = x;
            mvToX = x;
            mvFromZ = z;
            mvToZ = z+1;
            mvDist = 0;
        }
    } else if ((rotY >= 225) && (rotY < 315)) {    // nach links?
        if ((x > 0) && (sArray[z][x-1] == 0)) {
            mvId = sArray[z][x];
            mvFromX = x;
            mvToX = x-1;
            mvFromZ = z;
            mvToZ = z;
            mvDist = 0;
        }
    } else {
        if ((z > 0) && (sArray[z-1][x] == 0)) {    // nach oben?
            mvId = sArray[z][x];
            mvFromX = x;
            mvToX = x;
            mvFromZ = z;
            mvToZ = z-1;
            mvDist = 0;
        }
    }
    return false;
}

//-----------------------------------------------------------------------------

function getSceneGroundLevel(xp, yp, zp) {
    return 0;
}

