//-----------------------------------------------------------------------------
// w_hall.js - Halle mit mehreren Raeumen

var SceneVersion = "w_hall.js V16.02.18";
var SceneName = "Mehrzweckhalle";

var SceneObj;
var SceneId;

//-----------------------------------------------------------------------------

function buildScene(sid) {

    SceneId = sid;
    SceneObj = new THREE.Mesh();    // sammelt alle statischen Elemente der Kachel

    var cross = setAchsenkreuz(2);	// zur Orientierung
    cross.position.set(-45, 0.15, 35);
    SceneObj.add(cross);


    //------------------------------------------------------------------
    // OBJ/MTL-Loader; geht ab Three.js 7.4 etwas anders:

    var onProgress = function(xhr) { };
    var onError = function(xhr) { };

    THREE.Loader.Handlers.add(/\.dds$/i, new THREE.DDSLoader());
    var mtlLoader = new THREE.MTLLoader();
    mtlLoader.setBaseUrl('../models/male02/');
    mtlLoader.setPath( '../models/male02/' );
    mtlLoader.load('male02_dds.mtl', function(materials) {
        materials.preload();
        var objLoader = new THREE.OBJLoader();
        objLoader.setMaterials(materials);
        objLoader.setPath('../models/male02/');
        objLoader.load('male02.obj', function(object) {
            object.position.set(-34, 0, 1);
            object.scale.set(0.012, 0.012, 0.012);
            SceneObj.add(object);
        }, onProgress, onError);
    });

    //------------------------------------------------------------------


//    var text = "Text zum Ueben";
//    var obj = CanvasTextObject(text, "Bold 24px Arial", "rgba(255,255,0,0.95)");
//    obj.position.set(-44, 0, 34);
//    SceneObj.add(obj);

	return SceneObj;
}

//-----------------------------------------------------------------------------

function recvSceneData(rxText) {
}

//-----------------------------------------------------------------------------

function terminateScene() {
    if (SceneObj !== undefined)
        delete SceneObj;
}

//-----------------------------------------------------------------------------

function cycleScene(msPerFrame) {
}

//-----------------------------------------------------------------------------

function testScenePosition(xp, yp, zp) {
    return true;
}

//-----------------------------------------------------------------------------

function getSceneGroundLevel(xp, yp, zp) {
	return 0;
}
