//-----------------------------------------------------------------------------

var SceneVersion = "w1.js V16.02.06";
var SceneName = "Mittenszene";

var SceneObj = undefined;              // Sammelobjekt fuer diese Teilszene
var SceneId;

var objBild;

var platRad = 1.4;
var platform1 = 0;
var bPlat1 = false;
var platform2 = 0;
var bPlat2 = false;
var vscName = "";
var vscData = undefined;

var boundBoxes = undefined;


//-----------------------------------------------------------------------------

function buildEntryGate() {

    var matArray = [];
    matArray.push(new THREE.MeshLambertMaterial({color: 0x008F00, side:THREE.DoubleSide}));
    matArray.push(new THREE.MeshLambertMaterial({color: 0x00CFCF, side:THREE.DoubleSide}));
    matArray.push(new THREE.MeshLambertMaterial({color: 0x0000CF, side:THREE.DoubleSide}));
    matArray.push(new THREE.MeshLambertMaterial({color: 0xBFBF00, side:THREE.DoubleSide}));
    matArray.push(new THREE.MeshLambertMaterial({color: 0xBF0000, side:THREE.DoubleSide}));

    var gateObj = new THREE.Mesh();
    
    // Bodenplatte
    var z0 = 10;
    var geo = new THREE.CubeGeometry(6.0, 0.1, 10.0);
    var obj = new THREE.Mesh(geo, matArray[0]);
    obj.position.set(0, 0.02, z0 + 2);
    gateObj.add(obj);

    // runde Saeulensockel
    geo = new THREE.CylinderGeometry(0.4, 0.4, 0.4, 12, 2, 0);
    obj = new THREE.Mesh(geo, matArray[1]);
    obj.position.set(2.5, 0.3, z0);
    gateObj.add(obj);
    obj = new THREE.Mesh(geo, matArray[1]);
    obj.position.set(-2.5, 0.3, z0);
    gateObj.add(obj);

    // quadratische Zwischenplatten
    geo = new THREE.CubeGeometry(0.84, 0.15, 0.84);
    obj = new THREE.Mesh(geo, matArray[2]);
    obj.position.set(2.5, 0.55, z0);
    gateObj.add(obj);
    geo = new THREE.CubeGeometry(0.84, 0.15, 0.84);
    obj = new THREE.Mesh(geo, matArray[2]);
    obj.position.set(-2.5, 0.55, z0);
    gateObj.add(obj);

    // Saeulen    
    geo = new THREE.CylinderGeometry(0.3, 0.3, 3.2, 12, 2, 0);
    obj = new THREE.Mesh(geo, matArray[3]);
    obj.position.set(2.5, 2.1, z0);
    gateObj.add(obj);
    obj = new THREE.Mesh(geo, matArray[3]);
    obj.position.set(-2.5, 2.1, z0);
    gateObj.add(obj);

    // Querbalken oben
    geo = new THREE.CubeGeometry(6.0, 0.6, 0.8);
    obj = new THREE.Mesh(geo, matArray[2]);
    obj.position.set(0, 4.0, z0);
    gateObj.add(obj);

    geo = new THREE.CylinderGeometry(1.2, 1.2, 1.2, 3, 1, false);
    obj = new THREE.Mesh(geo, matArray[4]);
    obj.rotation.x = Math.PI*3/2;
    obj.scale.x = 4.2;
    obj.position.set(0, 4.9, z0);
    gateObj.add(obj);

    boundBoxes.push(new makeBBox(2.5, 0, z0, 0.6, 4.3, 0.6));
    boundBoxes.push(new makeBBox(-2.5, 0, z0, 0.6, 4.3, 0.6));

    gateObj.name = "EntryGate";
    return gateObj;
}

//-----------------------------------------------------------------------------

var TriggerPos = function(rad, col) {

    var mat = new THREE.MeshLambertMaterial({color:col, transparent:true, opacity:0.7, side:THREE.DoubleSide});
    var geo = new THREE.CylinderGeometry(rad, rad+0.2, 0.1, 16, 2, false);
    var obj = new THREE.Mesh(geo, mat);
    obj.position.y = 0.05;
    return obj;
};


//-----------------------------------------------------------------------------

function buildScene(sid) {

//    headLight.intensity = 0.8;

    vscDemoObj = undefined;
    vscDemoBoxes = undefined;
    vscBoxFrames = undefined;
    boundBoxes = undefined;

    SceneId = sid;
    SceneObj = new THREE.Mesh();
    boundBoxes = new Array();
        
    SceneObj.add(buildGround('../tex/checker.png'));
    SceneObj.add(buildPins());              // Raster von Pfaehlen bauen
    SceneObj.add(setAchsenkreuz(5));        // RGB-Achsenkreuz im Ursprung
    SceneObj.add(buildEntryGate());

    var txtObj = new CanvasTextObject("3D-Wiki",
        "Bold 32px Arial", "rgba(255,255,0,0.95)");
    txtObj.position.set(0, 4, 0);
    SceneObj.add(txtObj);

    var map = THREE.ImageUtils.loadTexture('../pics/basis2.jpg');
    map.wrapS = map.wrapT = THREE.RepeatWrapping;
    map.anisotropy = 16;
    var mat2 = new THREE.MeshLambertMaterial({map: map, side: THREE.DoubleSide});

/*
    var mat2;
    var texloader = new THREE.TextureLoader();
    texloader.load("../pics/basis2.jpg", function(tex) {
        tex.wrapS = tex.wrapT = THREE.RepeatWrapping;
        tex.anisotropy = 16;
        mat2 = new THREE.MeshBasicMaterial({map: tex});
    });
*/

    var geo = new THREE.CubeGeometry(15, 10, 0.2);
    objBild = new THREE.Mesh(geo, mat2);
    objBild.position.set(-50, 5, -35);
    SceneObj.add(objBild);


    var tanne = new Tanne();
    tanne.position.set(12, 0, 21);
    SceneObj.add(tanne);
    boundBoxes.push(new makeBBox(12, 0, 21, 4, 4.7, 4));

    tanne = new Tanne();
    tanne.position.set(-12, 0, 21);
    SceneObj.add(tanne);
    boundBoxes.push(new makeBBox(-12, 0, 21, 4, 4.7, 4));


    platform1 = new TriggerPos(platRad, 0xCF1010);
    platform1.position.set(33, 0.05, 40);
    SceneObj.add(platform1);

    platform2 = new TriggerPos(platRad, 0x10CF10);
    platform2.position.set(40, 0.05, 33);
    SceneObj.add(platform2);

    registerBBoxes(sid, boundBoxes, showBoundBoxes(boundBoxes));

    return SceneObj;
}

//-----------------------------------------------------------------------------

function recvSceneData(rxText) {

    if (vscData === undefined) {
        vscData = buildVscScene(vscName, rxText);
        registerVscData(SceneId, vscData);
    }
}

//-----------------------------------------------------------------------------

function terminateScene() {

    if (vscData !== undefined) {
        scene.remove(vscData[1]);
        delete vscData;
        vscData = undefined;
    }
}

//-----------------------------------------------------------------------------

function cycleScene(msPerFrame) {

    objBild.rotation.y -= msPerFrame * 0.001;

    if (platform1.position === undefined)    //@@
        return;

    if (!bPlat1) {
        var xplat = platform1.position.x;
        var zplat = platform1.position.z;
        if ((posX > xplat-platRad) && (posX < xplat+platRad)
            && (posZ > zplat-platRad) && (posZ < zplat+platRad)) {
            bPlat1 = true;
            // Szene aus Skript nachladen, falls noch nicht geschehen
            if (vscData === undefined) {
                vscRequest("w1Demo1.vsc", SceneId);
            } else {
                vscData[1].name = "Base1Obj";
                scene.add(vscData[1]);  // add() macht sichtbar
            }
            bPlat2 = false;
        }
    }

    if (!bPlat2) {
        var xplat = platform2.position.x;
        var zplat = platform2.position.z;
        if ((posX > xplat-platRad) && (posX < xplat+platRad)
            && (posZ > zplat-platRad) && (posZ < zplat+platRad)) {
            bPlat2 = true;
            // geladene Demo-Szene entfernen, falls vorhanden
            var selObj = scene.getObjectByName("Base1Obj");
            if (selObj !== undefined) {
                scene.remove(selObj);   // remove() verbirgt nur, loescht nicht
            }
            bPlat1 = false;
        }
    }
}

//-----------------------------------------------------------------------------

function testScenePosition(xp, yp, zp) {

    if (!testPinPosition(xp, yp, zp))
        return false;                   // Kollision mit gelber Saeule

    if ((xp > -55) && (xp < -45) && (yp > -20) && (yp < -30))
        return false;

    return true;
}

//-----------------------------------------------------------------------------

function getSceneGroundLevel(xp, yp, zp) {

    return 0;
}

